//Do required includes
#include <PA9.h>
#include "dserial.h"   // Include DSerial 
#include "gfx/all_gfx.c"
#include "gfx/all_gfx.h"

//Set up variables
bool enable = 1; 
bool bottom_screen = 0; 
bool top_screen = 1;

//Order of sprites important - bubbles must be higher (lower priority) than lines.
s8 bubblev_sprite = 9; 
s8 bubble_sprite = 8; 
s8 biglinet2_sprite = 7; 
s8 biglinet1_sprite = 6; 
s8 smalllinet2_sprite = 5; 
s8 smalllinet1_sprite = 4; 
s8 bigline2_sprite = 3; 
s8 bigline1_sprite = 2; 
s8 smallline2_sprite = 1; 
s8 smallline1_sprite = 0; 

s8 bubble_palette = 0;			
s8 smallline_palette = 1;			
s8 bigline_palette = 2;			
s16 bubble_x = ((256-64)/2)+1;    
s32 bubble_y = ((192-32)/2)-10; 
s16 bubble_x_loc=((256-64)/2)+1;
s16 bubblev_x = 54;    
s32 bubblev_y = 62; 
s16 bubblev_y_loc = 62; 
s8 pal_256=1; 
s16 max_x=142; 
s32 min_x=48; 
s16 max_y=112; 
s32 min_y=16;
s16 Xoffset=0 ; 
s32 Yoffset=0;
signed int Xaccel = 0;
signed int Yaccel = 0;
int nocard=0;
int DSerialCheck;
char buffer[32];
uint8 size;

int main(int argc, char ** argv)
{

	PA_Init(); //PAlib inits
	PA_InitVBL();
	
	//Initialise any motion/serial card
	PA_MotionInit();
	DSerialCheck = dseInit();
	if(DSerialCheck) dseBoot();

	//Define required Palettes
	PA_LoadSpritePal(bottom_screen, bubble_palette, (void*)bubble256t_Pal);	
	PA_LoadSpritePal(top_screen, bubble_palette, (void*)bubble256t_Pal);	
	PA_LoadSpritePal(bottom_screen, smallline_palette, (void*)smallline256_Pal);	
	PA_LoadSpritePal(bottom_screen, bigline_palette, (void*)bigline256_Pal);	
	PA_LoadSpritePal(top_screen, smallline_palette, (void*)smallline256_Pal);	
	PA_LoadSpritePal(top_screen, bigline_palette, (void*)bigline256_Pal);	

	//Define sprites and associated palettes			

	//Create bottom bubble sprite
	PA_CreateSprite(bottom_screen, bubble_sprite, (void*)bubble256t_Sprite, OBJ_SIZE_64X32, pal_256, bubble_palette, bubble_x, bubble_y); 

	//Create top bubble sprite
	//Rotate bubble image for top screen 270deg
	PA_SetRotsetNoZoom(top_screen, 0, 512/4); // angle, from 0 to 511 
	PA_CreateSprite(top_screen, bubblev_sprite, (void*)bubble256t_Sprite, OBJ_SIZE_64X32, pal_256, bubble_palette, bubblev_x, bubblev_y); 
	PA_SetSpriteRotEnable(top_screen,bubblev_sprite,0);
	PA_SetSpriteDblsize(top_screen, bubblev_sprite, enable);

	//create line markings on level - give impression of bubble inside (behind lines)
	PA_CreateSprite(bottom_screen, smallline1_sprite, (void*)smallline256_Sprite, OBJ_SIZE_16X32, pal_256, smallline_palette, 79, 70); 
	PA_CreateSprite(top_screen, smalllinet1_sprite, (void*)smallline256_Sprite, OBJ_SIZE_16X32, pal_256, smallline_palette, 102, 7); 
   PA_SetSpriteRotEnable(top_screen,smalllinet1_sprite,0);
	PA_SetSpriteDblsize(top_screen, smalllinet1_sprite, enable);
	
	PA_CreateSprite(bottom_screen, smallline2_sprite, (void*)smallline256_Sprite, OBJ_SIZE_16X32, pal_256, smallline_palette, 176, 70); 
   PA_CreateSprite(top_screen, smalllinet2_sprite, (void*)smallline256_Sprite, OBJ_SIZE_16X32, pal_256, smallline_palette, 102, 104); 
   PA_SetSpriteRotEnable(top_screen,smalllinet2_sprite,0);
	PA_SetSpriteDblsize(top_screen, smalllinet2_sprite, enable);

	PA_CreateSprite(bottom_screen, bigline1_sprite, (void*)bigline256_Sprite, OBJ_SIZE_16X32, pal_256, bigline_palette, 91, 70); 
	PA_CreateSprite(top_screen, biglinet1_sprite, (void*)bigline256_Sprite, OBJ_SIZE_16X32, pal_256, bigline_palette, 102, 19); 
   PA_SetSpriteRotEnable(top_screen,biglinet1_sprite,0);
	PA_SetSpriteDblsize(top_screen, biglinet1_sprite, enable);

	PA_CreateSprite(bottom_screen, bigline2_sprite, (void*)bigline256_Sprite, OBJ_SIZE_16X32, pal_256, bigline_palette, 164, 70); 
	PA_CreateSprite(top_screen, biglinet2_sprite, (void*)bigline256_Sprite, OBJ_SIZE_16X32, pal_256, bigline_palette, 102, 92); 
   PA_SetSpriteRotEnable(top_screen,biglinet2_sprite,0);
	PA_SetSpriteDblsize(top_screen, biglinet2_sprite, enable);
	
	//Load image background tilesets
	PA_EasyBgLoad(bottom_screen, 3, level256); 
	PA_EasyBgLoad(top_screen, 3, level256v); // Same thing, but on the top screen...

	//Initialise a background for text on both screens
	PA_InitText(bottom_screen, 0);  // Initialise the normal text on the bottom screen
	PA_InitText(top_screen, 0);  // Initialise the normal text on the bottom screen
	
	//Place some text on screens
	PA_OutputText(top_screen,9,0, "NDSpirit Level");
	PA_OutputText(top_screen,6,23,"Written By Bootlegger.");
	PA_OutputText(bottom_screen,4,0, "Press A To Re-Calibrate.");
	PA_OutputText(bottom_screen,10,23,"Version 1.0");


	//main loop		
	while(1) {

		//Check if motion/serial card insterted and run relevant routines
		if (PA_CheckDSMotion() || DSerialCheck) {	

	   	//do DMotion check routine
			if (PA_CheckDSMotion()) {
				//If A pressed then use current readings as default level
				if (Pad.Newpress.A) { 
			   	Xoffset=Motion.X; 
					if (Xoffset>=64) { Xoffset=64; } 
					if (Xoffset<=-64) { Xoffset=-64; } 
					Yoffset=Motion.Y; 
					if (Yoffset>=64) { Yoffset=64; }
					if (Yoffset<=-64) { Yoffset=-64; }
				}
				Xaccel = Motion.X; 
				Yaccel = Motion.Y;
				bubble_x_loc=-(Xoffset)+bubble_x+Xaccel;
				bubblev_y_loc=-(Yoffset)+bubblev_y+Yaccel;
			}
		
			//do DSerial check routine
			if(DSerialCheck) {
				size = dseAdcRead(buffer);
				if (size >= 2) {
					//If A pressed then use current readings as default level
					if (Pad.Newpress.A) { 
			   		Xoffset=buffer[1]; 
						if (Xoffset>=128+64) { Xoffset=128+64; } 
						if (Xoffset<=128-64) { Xoffset=128-64; } 
						Yoffset=buffer[0]; 
						if (Yoffset>=128+64) { Yoffset=128+64; }
						if (Yoffset<=128-64) { Yoffset=128-64; }
					}
					Xaccel = buffer[1]-128;
					Yaccel = buffer[0]-128;
					bubble_x_loc=-(Xoffset)+bubble_x+Xaccel;
					bubblev_y_loc=-(Yoffset)+bubblev_y+Yaccel;			
				}			
			}		
			//Check if nocard variable set - if so and managed to get here then
			//it means a card has been re-inserted so reset basic variable
			//and erase no card message from screen
			if (nocard) {
				nocard=0;
				bubble_x = ((256-64)/2)+1;    
				bubble_y = ((192-32)/2)-10; 
				bubble_x_loc=((256-64)/2)+1;
				bubblev_x = 54;
				bubblev_y = 62; 
				bubblev_y_loc = 62; 
				PA_OutputText(bottom_screen,1,17, "                              ");
				PA_OutputText(bottom_screen,3,18, "                         ");
			}		
		} else {
			//no motion card detected therefor alert user no card inserted
			//and allow bubbles to be moved by DPAD, then check for card again
			nocard=1;
			PA_OutputText(bottom_screen,1,17, "No Motion/Serial Card detected");
			PA_OutputText(bottom_screen,3,18, "Use DPAD to move bubble!!");
			if (Pad.Held.Right) bubble_x=bubble_x+1;
			if (Pad.Held.Left) bubble_x=bubble_x-1;
			if (Pad.Held.Up) bubblev_y=bubblev_y-1;
			if (Pad.Held.Down) bubblev_y=bubblev_y+1;				
			bubble_x_loc=-(Xoffset)+bubble_x;
			bubblev_y_loc=-(Yoffset)+bubblev_y;			
			PA_WaitForVBL();
			PA_MotionInit();
			DSerialCheck = dseInit();
			if (DSerialCheck) dseBoot();
		}		

		//Position bubbles based on re-calibration value and dpad or motion/serial values
		//also limit the max move of bubble to hit side of circle frame on screen.
		if (bubble_x_loc>=max_x) bubble_x_loc=max_x;
		if (bubble_x_loc<=min_x) bubble_x_loc=min_x;
		if (bubblev_y_loc>=max_y) bubblev_y_loc=max_y;
		if (bubblev_y_loc<=min_y) bubblev_y_loc=min_y;
		PA_SetSpriteXY(bottom_screen, bubble_sprite, bubble_x_loc, bubble_y); 
		PA_SetSpriteXY(top_screen, bubblev_sprite, bubblev_x, bubblev_y_loc); 

		//Sync
		PA_WaitForVBL();

	}
	
return 0;
}
